//+------------------------------------------------------------------+
//|                                               Moving Average.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#define MAGICMA  20050610

extern double Lots               = 0.1;
extern double MaximumRisk        = 0;
extern double DecreaseFactor     = 0;
extern double MovingPeriod       = 18;
extern double MovingPeriod1       = 28;
extern double MovingShift        = 0;
extern double TrailingStop = 0;
extern double f=0;
extern double lim=0;
extern double risk=0;
//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
//---- return orders volume
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//| Calculate optimal lot size                                       |
//+------------------------------------------------------------------+
/*double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
  }*/
//+------------------------------------------------------------------+
//| Check for open order conditions                                  |
//+------------------------------------------------------------------+
void CheckForOpen()
  {
   double ma;
   double ma1;
   double ma2;
   double ma3;
   int    res;
   

//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,MovingPeriod,0,MODE_EMA,PRICE_CLOSE,5);
   ma1=iMA(NULL,0,MovingPeriod1,MovingShift,MODE_EMA,PRICE_CLOSE,5);
   ma2=iMA(NULL,0,MovingPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   ma3=iMA(NULL,0,MovingPeriod1,MovingShift,MODE_EMA,PRICE_CLOSE,1);
//---- sell conditions
   if (ma1<ma && ma2<ma3) 
     {
      res=OrderSend(Symbol(),OP_SELL,Lots,NormalizeDouble(Bid,Digits),5,0,0,"",MAGICMA,0,Red);
      f=0;
      return;
     }
//---- buy conditions
   if (ma1>ma && ma2>ma3)
     {
      res=OrderSend(Symbol(),OP_BUY,Lots,NormalizeDouble(Ask,Digits),5,0,0,"",MAGICMA,0,Blue);
      f=0;
      return;
      
     }
     
//----
  }
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()
  {
   double ma;
   double ma1;
   double ma2;
   double ma3;
   double ichi;
   double ichi1;
   double ichi2;
   double ichi3;
   double ichi35;
   double ichi4;
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
//---- get Moving Average 
   ma=iMA(NULL,0,MovingPeriod,0,MODE_EMA,PRICE_CLOSE,5);
   ma1=iMA(NULL,0,MovingPeriod1,MovingShift,MODE_EMA,PRICE_CLOSE,5);
   ma2=iMA(NULL,0,MovingPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   ma3=iMA(NULL,0,MovingPeriod1,MovingShift,MODE_EMA,PRICE_CLOSE,0);
   ichi=iIchimoku(NULL,0,9,26,52,2,1);
   ichi1=iIchimoku(NULL,0,9,26,52,2,2);
   ichi2=iIchimoku(NULL,0,9,26,52,2,3);
   ichi3=iIchimoku(NULL,0,9,26,52,2,4);
   ichi35=iIchimoku(NULL,0,9,26,52,2,5);   
   ichi4=iIchimoku(NULL,0,9,26,52,1,1);
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if 
         (ma1<ma && ma2<ma3) 
         {OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
         f=0;
         break;
         }
         if ((ichi==ichi1) && (ichi<Bid-5*Point) && (ichi4>ichi) && (ichi4<Bid))//((Low[3]>Low[2]) && (Low[2]<Low[1]) && (Low[4]>OrderOpenPrice()))  
              {OrderModify(OrderTicket(),OrderOpenPrice(),ichi,OrderTakeProfit(),0,Green);
              return(0);
              }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if 
         (ma1>ma && ma2>ma3) 
         {OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
         f=0;
         break;
         }
         if ((ichi==ichi1) && (ichi >Ask+5*Point) && (ichi4<ichi) && (ichi4>Ask))//((High[3]<High[2]) && (High[2]>High[1])&& (High[4]<OrderOpenPrice()))
         {OrderModify(OrderTicket(),OrderOpenPrice(),ichi,OrderTakeProfit(),0,Red);
           return(0);
           }
           break;
        }
     }
//----
  }
//+------------------------------------------------------------------+
//| Start function                                                   |
//+------------------------------------------------------------------+
void start()
  {
//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;
//---- calculate open orders by current symbol
   if(CalculateCurrentOrders(Symbol())==0) CheckForOpen();
   else                                    CheckForClose();
//----
  }
//+------------------------------------------------------------------+